diff -Naurd cluster-3.0.0.rc2/gfs/gfs_grow/main.c cluster-3.0.0.rc3/gfs/gfs_grow/main.c
--- cluster-3.0.0.rc2/gfs/gfs_grow/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_grow/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -68,7 +68,7 @@
  */
 
 static uint64_t
-device_geometry(char *device)
+device_geometry(char *device_g)
 {
 	int fd;
 	uint64_t bytes;
@@ -77,10 +77,10 @@
 	if (override_device_size)
 		bytes = override_device_size;
 	else {
-		fd = open(device, O_RDONLY);
+		fd = open(device_g, O_RDONLY);
 		if (fd < 0) {
 			fprintf(stderr, "gfs_grow: can't open %s: %s\n",
-				device, strerror(errno));
+				device_g, strerror(errno));
 			exit(EXIT_FAILURE);
 		}
 
@@ -88,7 +88,7 @@
 		if (error) {
 			fprintf(stderr,
 				"gfs_grow: can't determine size of %s: %s\n",
-				device, strerror(errno));
+				device_g, strerror(errno));
 			exit(EXIT_FAILURE);
 		}
 
@@ -110,10 +110,13 @@
  */
 
 static int
-jread(int fd, char *file, void *buf, uint64_t size, uint64_t *offset)
+jread(int fd, const char *file, void *buf, uint64_t size, uint64_t *offset)
 {
 	struct gfs_ioctl gi;
-	char *argv[] = { "do_hfile_read", file };
+	char *argv[] = {
+		(char *)"do_hfile_read",
+		(char *)file
+	};
 	int error;
 
 	gi.gi_argc = 2;
@@ -141,10 +144,13 @@
  */
 
 static int
-jwrite(int fd, char *file, void *buf, uint64_t size, uint64_t *offset)
+jwrite(int fd, const char *file, void *buf, uint64_t size, uint64_t *offset)
 {
 	struct gfs_ioctl gi;
-	char *argv[] = { "do_hfile_write", file };
+	char *argv[] = {
+		(char *)"do_hfile_write",
+		(char *)file
+	};
 	int error;
 
 	gi.gi_argc = 2;
@@ -373,10 +379,13 @@
  */
 
 static uint64_t
-get_length(int fd, char *file)
+get_length(int fd, const char *file)
 {
 	struct gfs_ioctl gi;
-	char *argv[] = { "get_hfile_stat", file };
+	char *argv[] = {
+		(char *)"get_hfile_stat",
+		(char *)file
+	};
 	struct gfs_dinode di;
 	int error;
 
@@ -540,7 +549,7 @@
 {
 	int fd;
 	struct gfs_ioctl gi;
-	char *argv[] = { "get_super" };
+	char *argv[] = { (char *)"get_super" };
 	int error;
 
 	fd = open(fspath, O_RDONLY);
@@ -653,7 +662,7 @@
  *
  */
 
-uint64_t
+static uint64_t
 rgrp_length(uint64_t size)
 {
 	uint64_t bitbytes = RGRP_BITMAP_BLKS(&fs_sb) + 1;
@@ -681,7 +690,7 @@
  * Returns: The end of the new resource group
  */
 
-uint64_t
+static uint64_t
 make_rgrp(uint64_t offset, uint64_t size)
 {
 	struct rglist_entry *rgl = malloc(sizeof(struct rglist_entry));
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_jadd/main.c cluster-3.0.0.rc3/gfs/gfs_jadd/main.c
--- cluster-3.0.0.rc2/gfs/gfs_jadd/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_jadd/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -76,7 +76,7 @@
  */
 
 static uint64_t
-device_geometry(char *device)
+device_geometry(char *device_g)
 {
 	int fd;
 	uint64_t bytes;
@@ -85,10 +85,10 @@
 	if (override_device_size)
 		bytes = override_device_size;
 	else {
-		fd = open(device, O_RDONLY);
+		fd = open(device_g, O_RDONLY);
 		if (fd < 0) {
 			fprintf(stderr, "gfs_jadd: can't open %s: %s\n",
-				device, strerror(errno));
+				device_g, strerror(errno));
 			exit(EXIT_FAILURE);
 		}
 
@@ -96,7 +96,7 @@
 		if (error) {
 			fprintf(stderr,
 				"gfs_grow: can't determine size of %s: %s\n",
-				device, strerror(errno));
+				device_g, strerror(errno));
 			exit(EXIT_FAILURE);
 		}
 
@@ -117,11 +117,14 @@
  * Returns: Error code, or amount of data read
  */
 
-int
-jread(int fd, char *file, void *buf, uint64_t size, uint64_t *offset)
+static int
+jread(int fd, const char *file, void *buf, uint64_t size, uint64_t *offset)
 {
 	struct gfs_ioctl gi;
-	char *argv[] = { "do_hfile_read", file };
+	char *argv[] = {
+		(char *)"do_hfile_read",
+		(char *)file
+	};
 	int error;
 
 	gi.gi_argc = 2;
@@ -148,11 +151,14 @@
  * Returns: Error code, or the amount of data written
  */
 
-int
-jwrite(int fd, char *file, void *buf, uint64_t size, uint64_t *offset)
+static int
+jwrite(int fd, const char *file, void *buf, uint64_t size, uint64_t *offset)
 {
 	struct gfs_ioctl gi;
-	char *argv[] = { "do_hfile_write", file };
+	char *argv[] = {
+		(char *)"do_hfile_write",
+		(char *)file
+	};
 	int error;
 
 	gi.gi_argc = 2;
@@ -389,10 +395,13 @@
  */
 
 static uint64_t
-get_length(int fd, char *file)
+get_length(int fd, const char *file)
 {
 	struct gfs_ioctl gi;
-	char *argv[] = { "get_hfile_stat", file };
+	char *argv[] = {
+		(char *)"get_hfile_stat",
+		(char *)file
+	};
 	struct gfs_dinode di;
 	int error;
 
@@ -500,7 +509,9 @@
 {
 	int fd;
 	struct gfs_ioctl gi;
-	char *argv[] = { "get_super" };
+	char *argv[] = {
+		(char *)"get_super"
+	};
 	int error;
 
 	fd = open(fspath, O_RDONLY);
@@ -620,7 +631,7 @@
  *
  */
 
-uint64_t
+static uint64_t
 make_journal(uint64_t offset, uint64_t size)
 {
 	struct jilist_entry *jil = malloc(sizeof(struct jilist_entry));
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_mkfs/main.c cluster-3.0.0.rc3/gfs/gfs_mkfs/main.c
--- cluster-3.0.0.rc2/gfs/gfs_mkfs/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_mkfs/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -34,7 +34,7 @@
  *
  */
 
-static void print_usage()
+static void print_usage(void)
 {
   printf("Usage:\n");
   printf("\n");
@@ -204,7 +204,7 @@
  *
  */
 
-void are_you_sure(commandline_t *comline)
+static void are_you_sure(commandline_t *comline)
 {
 	char input[32];
 	struct volume_id *vid = NULL;
@@ -250,7 +250,7 @@
  *
  */
 
-void check_mount(char *device)
+static void check_mount(char *device)
 {
 	struct stat st_buf;
 	int fd;
@@ -281,7 +281,7 @@
  *
  */
 
-void print_results(commandline_t *comline)
+static void print_results(commandline_t *comline)
 {
   if (comline->quiet)
     return;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_mkfs/Makefile cluster-3.0.0.rc3/gfs/gfs_mkfs/Makefile
--- cluster-3.0.0.rc2/gfs/gfs_mkfs/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_mkfs/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -18,11 +18,10 @@
 	structures.o
 
 CFLAGS += -DHELPER_PROGRAM -D_FILE_OFFSET_BITS=64
-CFLAGS += -I${gfskincdir} -I${volidincdir}
+CFLAGS += -I${gfskincdir}
 CFLAGS += -I$(S)/../include -I$(S)/../libgfs
 CFLAGS += -I${incdir}
 
-LDFLAGS += -L${volidlibdir} -lvolume_id
 LDFLAGS += -L../libgfs -lgfs
 LDFLAGS += -L${libdir}
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_mkfs/structures.c cluster-3.0.0.rc3/gfs/gfs_mkfs/structures.c
--- cluster-3.0.0.rc2/gfs/gfs_mkfs/structures.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_mkfs/structures.c	2009-06-11 11:02:55.000000000 +0200
@@ -365,7 +365,7 @@
 
 static char *fill_rindex(commandline_t *comline, osi_list_t *rlist)
 {
-	struct gfs_rindex *ri, rindex;
+	struct gfs_rindex *ri, grindex;
 	rgrp_list_t *rl;
 	osi_list_t *tmp;
 	char *buf;
@@ -402,10 +402,10 @@
 		printf("\nResource Index data:\n");
 
 		for (r = 0; r < comline->rgrps; r++) {
-			gfs_rindex_in(&rindex, buf + r * sizeof(struct gfs_rindex));
+			gfs_rindex_in(&grindex, buf + r * sizeof(struct gfs_rindex));
 
 			printf("\n  Resource index %d\n", r);
-			gfs_rindex_print(&rindex);
+			gfs_rindex_print(&grindex);
 		}
 	}
 	return buf;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_quota/check.c cluster-3.0.0.rc3/gfs/gfs_quota/check.c
--- cluster-3.0.0.rc2/gfs/gfs_quota/check.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_quota/check.c	2009-06-11 11:02:55.000000000 +0200
@@ -195,7 +195,10 @@
 	hidden_blocks = compute_hidden_blocks(comline, fd);
 
 	do {
-		char *argv[] = { "do_hfile_read", "quota" };
+		char *argv[] = {
+			(char *)"do_hfile_read",
+			(char *)"quota"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;
@@ -238,7 +241,7 @@
  */
 
 static void
-print_list(char *str, osi_list_t *list)
+print_list(const char *str, osi_list_t *list)
 {
 #if 0
 	osi_list_t *tmp;
@@ -261,7 +264,7 @@
  */
 
 static int
-do_compare(char *type, osi_list_t *fs_list, osi_list_t *qf_list)
+do_compare(const char *type, osi_list_t *fs_list, osi_list_t *qf_list)
 {
 	osi_list_t *tmp1, *tmp2;
 	values_t *v1, *v2;
@@ -444,7 +447,10 @@
 		value = cpu_to_gfs64(value);
 
 		{
-			char *argv[] = { "do_hfile_write", "quota"};
+			char *argv[] = {
+				(char *)"do_hfile_write",
+				(char *)"quota"
+			};
 
 			gi.gi_argc = 2;
 			gi.gi_argv = argv;
@@ -463,7 +469,10 @@
 			v->v_id);
 
 		{
-			char *argv[] = { "do_quota_refresh", buf };
+			char *argv[] = {
+				(char *)"do_quota_refresh",
+				(char *)buf
+			};
 
 			gi.gi_argc = 2;
 			gi.gi_argv = argv;
@@ -507,7 +516,10 @@
 
 	for (;;) {
 		{
-			char *argv[] = { "do_hfile_read", "quota" };
+			char *argv[] = {
+				(char *)"do_hfile_read",
+				(char *)"quota"
+			};
 
 			gi.gi_argc = 2;
 			gi.gi_argv = argv;
@@ -526,7 +538,10 @@
 		value = cpu_to_gfs64(value);
 
 		{
-			char *argv[] = { "do_hfile_write", "quota" };
+			char *argv[] = {
+				(char *)"do_hfile_write",
+				(char *)"quota"
+			};
 
 			gi.gi_argc = 2;
 			gi.gi_argv = argv;
@@ -545,7 +560,10 @@
 			0);
 
 		{
-			char *argv[] = { "do_quota_refresh", buf };
+			char *argv[] = {
+				(char *)"do_quota_refresh",
+				(char *)buf
+			};
 
 			gi.gi_argc = 2;
 			gi.gi_argv = argv;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_quota/gfs_quota.h cluster-3.0.0.rc3/gfs/gfs_quota/gfs_quota.h
--- cluster-3.0.0.rc2/gfs/gfs_quota/gfs_quota.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_quota/gfs_quota.h	2009-06-11 11:02:55.000000000 +0200
@@ -77,6 +77,10 @@
 void do_get_super(int fd, struct gfs_sb *sb);
 void do_sync(commandline_t *comline);
 uint64_t compute_hidden_blocks(commandline_t *comline, int fd);
+void print_quota(commandline_t *comline,
+            int user, uint32_t id,
+            struct gfs_quota *q,
+            struct gfs_sb *sb);
 
 /*  check.c  */
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_quota/layout.c cluster-3.0.0.rc3/gfs/gfs_quota/layout.c
--- cluster-3.0.0.rc2/gfs/gfs_quota/layout.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_quota/layout.c	2009-06-11 11:02:55.000000000 +0200
@@ -22,12 +22,6 @@
 
 #define LAYOUT_DATA_QUANTUM (4194304)
 
-extern void
-print_quota(commandline_t *comline,
-            int user, uint32_t id,
-            struct gfs_quota *q,
-            struct gfs_sb *sb);
-
 struct extent {
         osi_list_t list;
 
@@ -143,7 +137,7 @@
         osi_list_t *tmp;
         buffer_t *b;
         struct gfs_meta_header mh;
-        char *type;
+        const char *type;
 
         for (tmp = w->blist.next; tmp != &w->blist; tmp = tmp->next) {
                 b = osi_list_entry(tmp, buffer_t, list);
@@ -391,7 +385,7 @@
  *
  */
 
-void
+static void
 compute_layout(char *path)
 {
         world_t w;
@@ -413,7 +407,9 @@
         check_for_gfs(fd, path);
 
         {
-                char *argv[] = { "get_super" };
+                char *argv[] = {
+			(char *)"get_super"
+		};
 
                 gi.gi_argc = 1;
                 gi.gi_argv = argv;
@@ -436,7 +432,9 @@
         w.hash_ptrs = w.hash_bsize / sizeof(uint64_t);
 
         for (;;) {
-                char *argv[] = { "get_file_meta_quota" };
+                char *argv[] = {
+			(char *)"get_file_meta_quota"
+		};
 
                 w.buf_data = malloc(w.buf_size);
                 if (!w.buf_data)
@@ -479,7 +477,7 @@
  * @argv:
  *
  */
-void 
+static void 
 print_quota_range(commandline_t *comline, int type, uint64_t start, 
                   unsigned int len)
 {
@@ -529,7 +527,10 @@
                 hidden_blocks = compute_hidden_blocks(comline, fd);
 
         do {
-                char *argv[] = { "do_hfile_read", "quota" };
+                char *argv[] = {
+			(char *)"do_hfile_read",
+			(char *)"quota"
+		};
 
                 gi.gi_argc = 2;
                 gi.gi_argv = argv;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_quota/main.c cluster-3.0.0.rc3/gfs/gfs_quota/main.c
--- cluster-3.0.0.rc2/gfs/gfs_quota/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_quota/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -36,7 +36,7 @@
  */
 
 static void
-print_usage()
+print_usage(void)
 {
 	printf("Usage:\n");
 	printf("\n");
@@ -96,7 +96,9 @@
 do_get_super(int fd, struct gfs_sb *sb)
 {
 	struct gfs_ioctl gi;
-	char *argv[] = { "get_super" };
+	char *argv[] = {
+		(char *)"get_super"
+	};
 	int error;
 
 	gi.gi_argc = 1;
@@ -260,7 +262,10 @@
 	int error;
 
 	{
-		char *argv[] = { "get_hfile_stat", "jindex" };
+		char *argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"jindex"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;	
@@ -275,7 +280,10 @@
 	}
 
 	{
-		char *argv[] = { "get_hfile_stat", "rindex" };
+		char *argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"rindex"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;	
@@ -290,7 +298,10 @@
 	}
 
 	{
-		char *argv[] = { "get_hfile_stat", "quota" };
+		char *argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"quota"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;	
@@ -305,7 +316,10 @@
 	}
 
 	{
-		char *argv[] = { "get_hfile_stat", "license" };
+		char *argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"license"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;	
@@ -402,7 +416,9 @@
 do_sync_one(char *filesystem)
 {
 	int fd;
-	char *argv[] = { "do_quota_sync" };
+	char *argv[] = {
+		(char *)"do_quota_sync"
+	};
 	struct gfs_ioctl gi;
 	int error;
 
@@ -485,7 +501,10 @@
 		comline->id);
 
 	{
-		char *argv[] = { "do_quota_read", buf };
+		char *argv[] = {
+			(char *)"do_quota_read",
+			(char *)buf
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;
@@ -639,7 +658,10 @@
 	new_value = cpu_to_gfs64(new_value);
 
 	{
-		char *argv[] = { "do_hfile_write", "quota" };
+		char *argv[] = {
+			(char *)"do_hfile_write",
+			(char *)"quota"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;
@@ -658,7 +680,10 @@
 		comline->id);
 
 	{
-		char *argv[] = { "do_quota_refresh", buf };
+		char *argv[] = {
+			(char *)"do_quota_refresh",
+			(char *)buf
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_tool/counters.c cluster-3.0.0.rc3/gfs/gfs_tool/counters.c
--- cluster-3.0.0.rc2/gfs/gfs_tool/counters.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_tool/counters.c	2009-06-11 11:02:55.000000000 +0200
@@ -172,12 +172,14 @@
 
 	for (;;) {
 		struct gfs_ioctl gi;
-		char *argv[] = { "get_counters" };
+		char *local_argv[] = {
+			(char *)"get_counters"
+		};
 		char data[SIZE];
 		int error;
 
 		gi.gi_argc = 1;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = data;
 		gi.gi_size = SIZE;
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_tool/df.c cluster-3.0.0.rc3/gfs/gfs_tool/df.c
--- cluster-3.0.0.rc2/gfs/gfs_tool/df.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_tool/df.c	2009-06-11 11:02:55.000000000 +0200
@@ -40,28 +40,28 @@
  * printit - parse out and print values according to the output type
  */
 static void printit(char *stat_gfs, const char *label, uint64_t used,
-		    uint64_t free, unsigned int percentage)
+		    uint64_t free_space, unsigned int percentage)
 {
 	uint64_t block_size = name2u64(stat_gfs, "bsize");
 
 	switch (output_type) {
 	case OUTPUT_BLOCKS:
 		printf("  %-15s%-15"PRIu64"%-15"PRIu64"%-15"PRIu64"%u%%\n",
-		       label, used + free, used, free, percentage);
+		       label, used + free_space, used, free_space, percentage);
 		break;
 	case OUTPUT_K:
 		printf("  %-15s%-15"PRIu64"%-15"PRIu64"%-15"PRIu64"%u%%\n",
-		       label, ((used + free) * block_size) / 1024,
-		       (used * block_size) / 1024, (free * block_size) / 1024,
+		       label, ((used + free_space) * block_size) / 1024,
+		       (used * block_size) / 1024, (free_space * block_size) / 1024,
 		       percentage);
 		break;
 	case OUTPUT_HUMAN:
 		/* Need to do three separate printfs here because function
 		   anthropomorphize re-uses the same static space. */
 		printf("  %-15s%-15s", label,
-		       anthropomorphize((used + free) * block_size));
+		       anthropomorphize((used + free_space) * block_size));
 		printf("%-15s", anthropomorphize(used * block_size));
-		printf("%-15s%u%%\n", anthropomorphize(free * block_size),
+		printf("%-15s%u%%\n", anthropomorphize(free_space * block_size),
 		       percentage);
 		break;
 	}
@@ -96,7 +96,9 @@
 
 
 	{
-		char *argv[] = { "get_stat_gfs" };
+		char *argv[] = {
+			(char *)"get_stat_gfs"
+		};
 
 		gi.gi_argc = 1;
 		gi.gi_argv = argv;
@@ -109,7 +111,9 @@
 			    error, strerror(errno));
 	}
 	{
-		char *argv[] = { "get_super" };
+		char *argv[] = {
+			(char *)"get_super"
+		};
 
 		gi.gi_argc = 1;
 		gi.gi_argv = argv;
@@ -122,7 +126,9 @@
 			    error, strerror(errno));
 	}
 	{
-		char *argv[] = { "get_args" };
+		char *argv[] = {
+			(char *)"get_args"
+		};
 
 		gi.gi_argc = 1;
 		gi.gi_argv = argv;
@@ -135,7 +141,9 @@
 			    error, strerror(errno));
 	}
 	{
-		char *argv[] = { "get_lockstruct" };
+		char *argv[] = {
+			(char *)"get_lockstruct"
+		};
 
 		gi.gi_argc = 1;
 		gi.gi_argv = argv;
@@ -148,8 +156,10 @@
 			    error, strerror(errno));
 	}
 	{
-		char *argv[] = { "get_hfile_stat",
-				 "jindex" };
+		char *argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"jindex"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;
@@ -162,8 +172,10 @@
 			    error, strerror(errno));
 	}
 	{
-		char *argv[] = { "get_hfile_stat",
-				 "rindex" };
+		char *argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"rindex"
+		};
 
 		gi.gi_argc = 2;
 		gi.gi_argv = argv;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_tool/gfs_tool.h cluster-3.0.0.rc3/gfs/gfs_tool/gfs_tool.h
--- cluster-3.0.0.rc2/gfs/gfs_tool/gfs_tool.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_tool/gfs_tool.h	2009-06-11 11:02:55.000000000 +0200
@@ -86,9 +86,9 @@
 char *get_list(void);
 char **str2lines(char *str);
 char *mp2cookie(char *mp, int ioctl_ok);
-char *name2value(char *str, char *name);
-uint32_t name2u32(char *str, char *name);
-uint64_t name2u64(char *str, char *name);
+char *name2value(char *str, const char *name);
+uint32_t name2u32(char *str, const char *name);
+uint64_t name2u64(char *str, const char *name);
 
 
 #endif /* __GFS_TOOL_DOT_H__ */
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_tool/layout.c cluster-3.0.0.rc3/gfs/gfs_tool/layout.c
--- cluster-3.0.0.rc2/gfs/gfs_tool/layout.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_tool/layout.c	2009-06-11 11:02:55.000000000 +0200
@@ -106,7 +106,7 @@
 	osi_list_t *tmp;
 	buffer_t *b;
 	struct gfs_meta_header mh;
-	char *type;
+	const char *type;
 
 	for (tmp = w->blist.next; tmp != &w->blist; tmp = tmp->next) {
 		b = osi_list_entry(tmp, buffer_t, list);
@@ -321,7 +321,7 @@
 	struct gfs_leaf leaf;
 	uint32_t hsize, len;
 	uint32_t ht_offset, lp_offset, ht_offset_cur = -1;
-	uint32_t index = 0;
+	uint32_t lindex = 0;
 	uint64_t lp[w->hash_ptrs];
 	uint64_t leaf_no;
 
@@ -329,9 +329,9 @@
 	if (hsize * sizeof(uint64_t) != w->di.di_size)
 		die("bad hash table size\n");
 
-	while (index < hsize) {
-		lp_offset = index % w->hash_ptrs;
-		ht_offset = index - lp_offset;
+	while (lindex < hsize) {
+		lp_offset = lindex % w->hash_ptrs;
+		ht_offset = lindex - lp_offset;
 
 		if (ht_offset_cur != ht_offset) {
 			journaled_read(w, (char *) lp,
@@ -349,12 +349,12 @@
 
 		len = 1 << (w->di.di_depth - leaf.lf_depth);
 
-		lc(w, index, len, leaf_no, data);
+		lc(w, lindex, len, leaf_no, data);
 
-		index += len;
+		lindex += len;
 	}
 
-	if (index != hsize)
+	if (lindex != hsize)
 		die("screwed up directory\n");
 }
 
@@ -461,7 +461,7 @@
 {
 	do_pf_t pf;
 	unsigned int h;
-	char *type;
+	const char *type;
 
 	switch (w->di.di_type) {
 	case GFS_FILE_REG:
@@ -540,7 +540,7 @@
  */
 
 static void
-do_lc(world_t *w, uint32_t index, uint32_t len, uint64_t leaf_no, void *data)
+do_lc(world_t *w, uint32_t lindex, uint32_t len, uint64_t leaf_no, void *data)
 {
 	buffer_t *b;
 	struct gfs_leaf leaf;
@@ -551,8 +551,8 @@
 		gfs_leaf_in(&leaf, b->data);
 
 		printf("  %.8X             %.8X             %-20" PRIu64
-		       " %u\n", index << (32 - w->di.di_depth),
-		       ((index + len) << (32 - w->di.di_depth)) - 1, blk,
+		       " %u\n", lindex << (32 - w->di.di_depth),
+		       ((lindex + len) << (32 - w->di.di_depth)) - 1, blk,
 		       leaf.lf_entries);
 	}
 
@@ -598,17 +598,16 @@
 			  sizeof(struct gfs_meta_header)))
 
 static void
-print_eattr_data(world_t *w, uint64_t blkno, int *first)
+print_eattr_data(world_t *w, uint64_t eblkno, int *first)
 {
-	buffer_t *b = getbuf(w, blkno);
 	struct gfs_ea_header *ea;
 
-	ea = GFS_EA_BH2FIRST(b);
+	ea = GFS_EA_BH2FIRST(getbuf(w, eblkno));
 	for (;;) {
 		if (!GFS_EA_IS_STUFFED(ea)) {
 			char name[300];
 			uint64_t *p, blkno;
-			uint64_t b;
+			uint64_t d;
 			unsigned int l;
 			unsigned int x;
 			int c;
@@ -623,7 +622,6 @@
 			if (ea->ea_type == GFS_EATYPE_UNUSED)
 				strcpy(name, "unused");
 			else {
-				unsigned int x;
 				switch (ea->ea_type) {
 				case GFS_EATYPE_USR:
 					strcpy(name, "user.");
@@ -641,31 +639,32 @@
 				name[x + ea->ea_name_len] = 0;
 			}
 
-			b = 0;
+			d = 0;
 			l = 0;
+			x = 0;
 			c = FALSE;
 
 			p = GFS_EA2DATAPTRS(ea);
 			for (x = 0; x < ea->ea_num_ptrs; x++) {
 				blkno = gfs64_to_cpu(*p);
-				if (b + l == blkno)
+				if (d + l == blkno)
 					l++;
 				else {
-					if (b) {
+					if (d) {
 						printf("  %-20" PRIu64
-						       " %-10u %s\n", b, l,
+						       " %-10u %s\n", d, l,
 						       name);
 						if (!c) {
 							strcat(name, " (cont)");
 							c = TRUE;
 						}
 					}
-					b = blkno;
+					d = blkno;
 					l = 1;
 				}
 				p++;
 			}
-			printf("  %-20" PRIu64 " %-10u %s\n", b, l, name);
+			printf("  %-20" PRIu64 " %-10u %s\n", d, l, name);
 		}
 		if (GFS_EA_IS_LAST(ea))
 			break;
@@ -775,10 +774,12 @@
 	check_for_gfs(fd, path);
 
 	{
-		char *argv[] = { "get_super" };
+		char *local_argv[] = {
+			(char *)"get_super"
+		};
 
 		gi.gi_argc = 1;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = (char *)&w.sb;
 		gi.gi_size = sizeof(struct gfs_sb);
 
@@ -797,14 +798,16 @@
 	w.hash_ptrs = w.hash_bsize / sizeof(uint64_t);
 
 	for (;;) {
-		char *argv[] = { "get_file_meta" };
+		char *local_argv[] = {
+			(char *)"get_file_meta"
+		};
 
 		w.buf_data = malloc(w.buf_size);
 		if (!w.buf_data)
 			die("out of memory\n");
 
 		gi.gi_argc = 1;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = w.buf_data;
 		gi.gi_size = w.buf_size;
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_tool/misc.c cluster-3.0.0.rc3/gfs/gfs_tool/misc.c
--- cluster-3.0.0.rc2/gfs/gfs_tool/misc.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_tool/misc.c	2009-06-11 11:02:55.000000000 +0200
@@ -27,7 +27,9 @@
 void
 do_file_flush(int argc, char **argv)
 {
-	char *gi_argv[] = { "do_file_flush" };
+	char *gi_argv[] = {
+		(char *)"do_file_flush"
+	};
 	struct gfs_ioctl gi;
 	int fd;
 	int error;
@@ -250,7 +252,7 @@
 set_flag(int argc, char **argv)
 {
 	struct gfs_dinode di;
-	char *set;
+	const char *set;
 	char *flag;
 	struct gfs_ioctl gi;
 	int fd;
@@ -273,9 +275,11 @@
 		check_for_gfs(fd, argv[optind]);
 
 		{
-			char *gi_argv[] = { "set_file_flag",
-					    set,
-					    flag };
+			char *gi_argv[] = {
+				(char *)"set_file_flag",
+				(char *)set,
+				(char *)flag
+			};
 			gi.gi_argc = 3;
 			gi.gi_argv = gi_argv;
 
@@ -299,7 +303,9 @@
 print_stat(int argc, char **argv)
 {
 	int fd;
-	char *gi_argv[] = { "get_file_stat" };
+	char *gi_argv[] = {
+		(char *)"get_file_stat"
+	};
 	struct gfs_ioctl gi;
 	struct gfs_dinode di;
 	int error;
@@ -341,7 +347,9 @@
 print_sb(int argc, char **argv)
 {
 	int fd;
-	char *gi_argv[] = { "get_super" };
+	char *gi_argv[] = {
+		(char *)"get_super"
+	};
 	struct gfs_ioctl gi;
 	struct gfs_sb sb;
 	int error;
@@ -398,12 +406,14 @@
 
 
 	{
-		char *argv[] = { "get_hfile_stat",
-				 "jindex" };
+		char *local_argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"jindex"
+		};
 		struct gfs_dinode di;
 
 		gi.gi_argc = 2;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = (char *)&di;
 		gi.gi_size = sizeof(struct gfs_dinode);
 
@@ -417,13 +427,15 @@
 
 
 	for (offset = 0, x = 0; ; offset += sizeof(struct gfs_jindex), x++) {
-		char *argv[] = { "do_hfile_read",
-				 "jindex" };
+		char *local_argv[] = {
+			(char *)"do_hfile_read",
+			(char *)"jindex"
+		};
 		char buf[sizeof(struct gfs_jindex)];
 		struct gfs_jindex ji;
 		
 		gi.gi_argc = 2;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = buf;
 		gi.gi_size = sizeof(struct gfs_jindex);
 		gi.gi_offset = offset;
@@ -473,12 +485,14 @@
 
 
 	{
-		char *argv[] = { "get_hfile_stat",
-				 "rindex" };
+		char *local_argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"rindex"
+		};
 		struct gfs_dinode di;
 
 		gi.gi_argc = 2;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = (char *)&di;
 		gi.gi_size = sizeof(struct gfs_dinode);
 
@@ -492,13 +506,15 @@
 
 
 	for (offset = 0, x = 0; ; offset += sizeof(struct gfs_rindex), x++) {
-		char *argv[] = { "do_hfile_read",
-				 "rindex" };
+		char *local_argv[] = {
+			(char *)"do_hfile_read",
+			(char *)"rindex"
+		};
 		char buf[sizeof(struct gfs_rindex)];
 		struct gfs_rindex ri;
 		
 		gi.gi_argc = 2;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = buf;
 		gi.gi_size = sizeof(struct gfs_rindex);
 		gi.gi_offset = offset;
@@ -548,12 +564,14 @@
 
 
 	{
-		char *argv[] = { "get_hfile_stat",
-				 "quota" };
+		char *local_argv[] = {
+			(char *)"get_hfile_stat",
+			(char *)"quota"
+		};
 		struct gfs_dinode di;
 
 		gi.gi_argc = 2;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = (char *)&di;
 		gi.gi_size = sizeof(struct gfs_dinode);
 
@@ -567,13 +585,15 @@
 
 
 	for (offset = 0, x = 0; ; offset += sizeof(struct gfs_quota), x++) {
-		char *argv[] = { "do_hfile_read",
-				 "quota" };
+		char *local_argv[] = {
+			(char *)"do_hfile_read",
+			(char *)"quota"
+		};
 		char buf[sizeof(struct gfs_quota)];
 		struct gfs_quota q;
 		
 		gi.gi_argc = 2;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 		gi.gi_data = buf;
 		gi.gi_size = sizeof(struct gfs_quota);
 		gi.gi_offset = offset;
@@ -624,7 +644,9 @@
 reclaim_metadata(int argc, char **argv)
 {
 	int fd;
-	char *gi_argv[] = { "do_reclaim" };
+	char *gi_argv[] = {
+		(char *)"do_reclaim"
+	};
 	struct gfs_ioctl gi;
 	char buf[256];
 
@@ -671,7 +693,9 @@
 do_shrink(int argc, char **argv)
 {
 	int fd;
-	char *gi_argv[] = { "do_shrink" };
+	char *gi_argv[] = {
+		(char *)"do_shrink"
+	};
 	struct gfs_ioctl gi;
 
 	if (optind == argc)
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_tool/tune.c cluster-3.0.0.rc3/gfs/gfs_tool/tune.c
--- cluster-3.0.0.rc2/gfs/gfs_tool/tune.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_tool/tune.c	2009-06-11 11:02:55.000000000 +0200
@@ -29,7 +29,9 @@
 get_tune(int argc, char **argv)
 {
 	int fd;
-	char *gi_argv[] = { "get_tune" };
+	char *gi_argv[] = {
+		(char *)"get_tune"
+	};
 	struct gfs_ioctl gi;
 	char str[SIZE], str2[SIZE];
 	char **lines, **l;
@@ -121,10 +123,14 @@
 	}
 
 	{
-		char *argv[] = { "set_tune", param, value };
+		char *local_argv[] = {
+			(char *)"set_tune",
+			(char *)param,
+			(char *)value
+		};
 
 		gi.gi_argc = 3;
-		gi.gi_argv = argv;
+		gi.gi_argv = local_argv;
 
 		if (ioctl(fd, GFS_IOCTL_SUPER, &gi))
 			die("can't change tunable parameter %s: %s\n",
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_tool/util.c cluster-3.0.0.rc3/gfs/gfs_tool/util.c
--- cluster-3.0.0.rc2/gfs/gfs_tool/util.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_tool/util.c	2009-06-11 11:02:55.000000000 +0200
@@ -170,7 +170,9 @@
 
 	if (ioctl_ok) {
 		struct gfs_ioctl gi;
-		char *argv[] = { "get_cookie" };
+		char *argv[] = {
+			(char *)"get_cookie"
+		};
 		int fd;
 
 		gi.gi_argc = 1;
@@ -206,7 +208,7 @@
  */
 
 char *
-name2value(char *str_in, char *name)
+name2value(char *str_in, const char *name)
 {
 	char str[strlen(str_in) + 1];
 	static char value[256];
@@ -240,7 +242,7 @@
  */
 
 uint32_t
-name2u32(char *str, char *name)
+name2u32(char *str, const char *name)
 {
 	char *value = name2value(str, name);
 	uint32_t x = 0;
@@ -259,7 +261,7 @@
  */
 
 uint64_t
-name2u64(char *str, char *name)
+name2u64(char *str, const char *name)
 {
 	char *value = name2value(str, name);
 	uint64_t x = 0;
diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/file.c cluster-3.0.0.rc3/gfs/libgfs/file.c
--- cluster-3.0.0.rc2/gfs/libgfs/file.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/file.c	2009-06-11 11:02:55.000000000 +0200
@@ -11,7 +11,7 @@
  *
  * Returns: The amount of data actually copied or the error
  */
-int readi(int disk_fd, struct gfs_inode *ip, void *buf, uint64 offset,
+int readi(int disk_fd, struct gfs_inode *ip, void *bufin, uint64 offset,
 		  unsigned int size)
 {
 	struct gfs_sbd *sdp = ip->i_sbd;
@@ -23,6 +23,7 @@
 	int journaled = fs_is_jdata(ip);
 	int copied = 0;
 	int error = 0;
+	char *buf = bufin;
 
 	if (offset >= ip->i_di.di_size){
 		log_debug("readi:  Offset (%"PRIu64") is >= "
@@ -109,7 +110,7 @@
  *
  * Returns: The number of bytes correctly written or error code
  */
-int writei(int disk_fd, struct gfs_inode *ip, void *buf, uint64_t offset,
+int writei(int disk_fd, struct gfs_inode *ip, void *bufin, uint64_t offset,
 		   unsigned int size)
 {
 	struct gfs_sbd *sdp = ip->i_sbd;
@@ -122,6 +123,7 @@
 	const uint64_t start = offset;
 	int copied = 0;
 	int error = 0;
+	char *buf = bufin;
 
 	/*  Bomb out on writing nothing.
 	    Posix says we can't change the time here.  */
diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/fs_bits.c cluster-3.0.0.rc3/gfs/libgfs/fs_bits.c
--- cluster-3.0.0.rc2/gfs/libgfs/fs_bits.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/fs_bits.c	2009-06-11 11:02:55.000000000 +0200
@@ -28,7 +28,7 @@
 	*byte |= new_state << bit;
 }
 
-uint32_t fs_bitfit_core(struct gfs_sbd *sbp, uint64_t goal, uint64_t start,
+static uint32_t fs_bitfit_core(struct gfs_sbd *sbp, uint64_t goal, uint64_t start,
 						uint64_t len, unsigned char old_state)
 {
 	uint64_t block;
